<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="148px">
<!--      <el-form-item label="外部联系人名称" prop="extName">
        <el-input
          v-model="queryParams.extName"
          placeholder="请输入外部联系人名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>-->
      <el-form-item label="所属销售" prop="companyUserId">
        <el-select v-model="queryParams.companyUserId" clearable filterable remote
                   placeholder="请输入关键词" :remote-method="loadCompanyUserOptions"
                   v-select-load-more="loadMoreCompanyUserOptions"
                   :loading="companyUserOptionsLoading">
          <el-option
            v-for="item in companyUserOptions"
            :key="item.value"
            :label="item.label"
            :value="item.value">
          </el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="企微用户名称" prop="qwUserName">
        <el-input
          v-model="queryParams.qwUserName"
          placeholder="请输入企微用户名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
<!--      <el-form-item label="标题" prop="title">
        <el-input
          v-model="queryParams.title"
          placeholder="请输入标题"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>-->
<!--      <el-form-item label="通话状态" prop="status">
        <el-select v-model="queryParams.status" placeholder="请选择通话状态" clearable size="small">
          <el-option
            v-for="dict in statusOptions"
            :key="dict.dictValue"
            :label="dict.dictLabel"
            :value="dict.dictValue"
          />
        </el-select>
      </el-form-item>-->
<!--      <el-form-item label="企微id" prop="corpId">
        <el-input
          v-model="queryParams.corpId"
          placeholder="请输入企微id"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>-->
<!--      <el-form-item label="公司名称" prop="companyName">
        <el-input
          v-model="queryParams.companyName"
          placeholder="请输入公司名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>-->

<!--      <el-form-item label="时长秒" prop="duration">
        <el-input
          v-model="queryParams.duration"
          placeholder="请输入时长秒"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>-->
      <el-form-item label="创建时间" prop="createTime">
        <el-date-picker v-model="createTime" size="small" style="width: 220px"
                        value-format="yyyy-MM-dd" type="daterange" range-separator="-"
                        start-placeholder="开始日期" end-placeholder="结束日期"
                        @change="changeTime"></el-date-picker>
      </el-form-item>

      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>

    </el-form>

    <el-row :gutter="10" class="mb8">
<!--      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['qw:qwUserVoiceLog:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['qw:qwUserVoiceLog:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['qw:qwUserVoiceLog:remove']"
        >删除</el-button>
      </el-col>-->
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          :loading="exportLoading"
          @click="handleExport"
          v-hasPermi="['qw:qwUserVoiceLog:totalExport']"
        >导出</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          size="mini"
          @click="getSellList"
        >切换到销售统计</el-button>
      </el-col>

      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          size="mini"
          @click="getList"
        >切回企微通话统计</el-button>
      </el-col>

      <right-toolbar :showSearch.sync="showSearch" @queryTable="handlePagination"></right-toolbar>
    </el-row>

    <el-table border v-loading="loading" :data="qwUserVoiceLogList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
<!--      <el-table-column label="id" align="center" width="80" prop="id" />-->
<!--      <el-table-column label="外部联系人名称" align="center" prop="qwExternalContact.name" />-->
      <el-table-column label="销售名称" align="center" prop="companyUserName" />
      <el-table-column label="企微用户名称" align="center" prop="qwUser.qwUserName" />
      <el-table-column label="企微主体名称" align="center" prop="corpName" />
      <el-table-column label="企微用户id" align="center" prop="qwUser.qwUserId" />
      <el-table-column label="时长秒" align="center"  prop="duration" />
      <el-table-column label="接通数量" align="center"  prop="connectCount" />
      <el-table-column label="未接通数量" align="center"  prop="noConnectCount" />
<!--      <el-table-column label="标题" align="center" width="80" prop="title" />-->
<!--      <el-table-column label="通话状态" align="center" prop="status">
        <template slot-scope="scope">
          <dict-tag :options="statusOptions" :value="scope.row.status"/>
        </template>
      </el-table-column>-->
      <!--<el-table-column label="公司名称" align="center" prop="company.companyName" />
      <el-table-column label="销售用户名称" align="center" prop="companyUser.userName" />
      <el-table-column label="创建时间" align="center" prop="createTime" />-->
<!--      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['qw:qwUserVoiceLog:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['qw:qwUserVoiceLog:remove']"
          >删除</el-button>
        </template>
      </el-table-column>-->
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="handlePagination"
    />
  </div>
</template>

<script>
import { listQwUserVoiceLog, getQwUserVoiceLog, delQwUserVoiceLog, addQwUserVoiceLog, updateQwUserVoiceLog, exportQwUserVoiceLog } from "@/api/qw/qwUserVoiceLog";
import {listQwUserVoiceLogTotal,exportQwUserVoiceLogTotal,listQwUserVoiceLogSellTotal,exportQwUserVoiceLogSellTotal} from "@/api/qw/qwUserVoiceLogTotal";
import {getCompanyUserListLikeName} from "@/api/company/companyUser";

export default {
  name: "QwUserVoiceLog",
  data() {
    return {
      // 遮罩层
      loading: true,
      status: 0,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      //时间范围
      createTime:null,
      beginTime:null,
      endTime:null,
      // 总条数
      total: 0,
      // 企微用户通话记录表格数据
      qwUserVoiceLogList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 1接听 2未接字典
      statusOptions: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        extId: null,
        extName:null,
        qwUserId: null,
        qwUserName: null,
        duration: null,
        title: null,
        status: null,
        corpName: null,
        companyId: null,
        companyName: null,
        companyUserId: null,
        companyUserName: null,
        createTime:null,
        beginTime:null,
        endTime:null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      },
      companyUserOptionsLoading: false,
      companyUserOptions: [],
      companyUserOptionsParams: {
        name: undefined,
        hasNextPage: false,
        pageNum: 1,
        pageSize: 10
      },
    };
  },
  created() {
    this.handlePagination();
    this.getDicts("sys_qw_user_voice_status").then(response => {
      this.statusOptions = response.data;
    });
  },
  methods: {
    /** 查询企微用户通话记录列表 */
    getList() {
      this.loading = true;
      this.status = 0;
      listQwUserVoiceLogTotal(this.queryParams).then(response => {
        this.qwUserVoiceLogList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    getSellList() {
      this.loading = true;
      this.status = 1;
      listQwUserVoiceLogSellTotal(this.queryParams).then(response => {
        this.qwUserVoiceLogList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 新增 handlePagination 方法
    handlePagination() {
      if (this.status === 0) {
        this.getList();
      } else {
        this.getSellList();
      }
    },
    /**
     * 根据名称模糊查询用户列表
     * @param query 参数
     */
    loadCompanyUserOptions(query) {
      this.companyUserOptions = [];
      if (query === '') {
        return;
      }

      this.companyUserOptionsParams.pageNum = 1
      this.companyUserOptionsParams.name = query
      this.companyUserOptionsLoading = true;
      this.getCompanyUserListLikeName()
    },
    getCompanyUserListLikeName() {
      getCompanyUserListLikeName(this.companyUserOptionsParams).then(response => {
        this.companyUserOptions = [...this.companyUserOptions, ...response.data.list]
        this.companyUserOptionsParams.hasNextPage = response.data.hasNextPage
        this.companyUserOptionsLoading = false;
      });
    },
    /**
     * 加载更多员工选项
     */
    loadMoreCompanyUserOptions() {
      if (!this.companyUserOptionsParams.hasNextPage) {
        return;
      }

      this.companyUserOptionsParams.pageNum += 1
      this.getCompanyUserListLikeName()
    },
    changeTime(){
      if(this.createTime!=null){
        this.queryParams.beginTime=this.createTime[0];
        this.queryParams.endTime=this.createTime[1];
      }else{
        this.queryParams.beginTime=null;
        this.queryParams.endTime=null;
      }
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        extId: null,
        qwUserId: null,
        duration: null,
        title: null,
        status: 0,
        corpId: null,
        companyId: null,
        companyUserId: null,
        createTime: null,
        beginTime:null,
        endTime:null,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.handlePagination();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.createTime=null;
      this.queryParams.beginTime = null;
      this.queryParams.endTime = null;
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加企微用户通话记录";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getQwUserVoiceLog(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改企微用户通话记录";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateQwUserVoiceLog(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.handlePagination();
            });
          } else {
            addQwUserVoiceLog(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.handlePagination();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除企微用户通话记录编号为"' + ids + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delQwUserVoiceLog(ids);
        }).then(() => {
          this.handlePagination();
          this.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有企微用户通话记录数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
          this.exportLoading = true;
        if(this.status === 0){
          return exportQwUserVoiceLogTotal(queryParams);
        }else{
          return exportQwUserVoiceLogSellTotal(queryParams);
        }

        }).then(response => {
          this.download(response.msg);
          this.exportLoading = false;
        }).catch(() => {});
    }
  }
};
</script>
